
function getLocalizedString(key)
{
    try {
		var ret = localizedStrings[key];
		if (ret === undefined) {
			ret = key;
		}
		return ret;
    } catch (ex) {}

	return key;
}

var debug_mode;
function dlog(msg) 
{
	if (debug_mode == true) {
		alert(msg);
	}
}

/*
	flip
*/
var flipShown = false;
var animation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, firstElement:null, timer:null};

function flip_mousemove(event)
{
    if (!flipShown) {
        if (animation.timer != null) {
            clearInterval(animation.timer);
            animation.timer  = null;
        }
 
        var starttime = (new Date).getTime() - 13;
 
        animation.duration = 500;
        animation.starttime = starttime;
        animation.firstElement = document.getElementById("flip");
        animation.timer = setInterval("animate();", 13);
        animation.from = animation.now;
        animation.to = 1.0;
        animate();
        flipShown = true;
    }
}

function flip_mouseexit(event)
{
    if (flipShown) {
        // fade in the info button
        if (animation.timer != null) {
            clearInterval(animation.timer);
            animation.timer  = null;
        }
 
        var starttime = (new Date).getTime() - 13;
 
        animation.duration = 500;
        animation.starttime = starttime;
        animation.firstElement = document.getElementById("flip");
        animation.timer = setInterval("animate();", 13);
        animation.from = animation.now;
        animation.to = 0.0;
        animate();
        flipShown = false;
    }
}
 
function animate()
{
    var T;
    var ease;
    var time = (new Date).getTime();
 
 
    T = limit_3(time-animation.starttime, 0, animation.duration);
 
    if (T >= animation.duration) {
        clearInterval(animation.timer);
        animation.timer = null;
        animation.now = animation.to;
    } else {
        ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
        animation.now = computeNextFloat (animation.from, animation.to, ease);
    }
 
    animation.firstElement.style.opacity = animation.now;
}
 
function limit_3(a, b, c)
{
    return a < b ? b : (a > c ? c : a);
}
 
function computeNextFloat(from, to, ease)
{
    return from + (to - from) * ease;
}

function enterflip(event)
{
    document.getElementById("fliprollie").style.display = "block";
}
 
function exitflip(event)
{
    document.getElementById("fliprollie").style.display = "none";
}

/*
	resize 
 */
var lastPos; 
var g_resizeCallback = null;

function resize_mousedown(event) 
{ 
    var x = event.x + window.screenX; 
    var y = event.y + window.screenY; 
    document.addEventListener("mousemove", resize_mousemove, true); 
    document.addEventListener("mouseup", resize_mouseup, true); 
    lastPos = {x:x, y:y}; 
    event.stopPropagation(); 
    event.preventDefault(); 
} 

function resize_mousemove(event) 
{ 
    var screenX = event.x + window.screenX; 
    var screenY = event.y + window.screenY; 
    window.resizeBy(screenX - lastPos.x, screenY - lastPos.y); 
    lastPos = {x:screenX, y:screenY}; 
    event.stopPropagation(); 
    event.preventDefault(); 
    if (g_resizeCallback) {
    	g_resizeCallback();
    }
} 

function resize_mouseup(event) 
{ 
    document.removeEventListener("mousemove", resize_mousemove, true); 
    document.removeEventListener("mouseup", resize_mouseup, true); 
    event.stopPropagation(); 
    event.preventDefault(); 
    
    if (window.widget) {
    	widget.setPreferenceForKey(window.innerWidth, "windowWidth");
    	widget.setPreferenceForKey(window.innerHeight, "windowHeight");
    }
    if (g_resizeCallback) {
    	g_resizeCallback();
    }
} 

function setResizeCallback(callback)
{
	g_resizeCallback = callback;
}

/*
 other util
*/
function getLength(arr)
{
	var len = 0;
	for (var i in arr) {
		if (arr[i]) {
			len++;
		}
	}
	return len;
}

function containsObject(arr, obj)
{
	for (var i in arr) {
		if (obj == arr[i]) {
			return true;
		}
	}
	return false;
}

function openWeb(url)
{
	if (widget) {
		widget.openURL(url);
	}
}

function convertEncoding(string, from, to)
{
    if (!from) {
        from = "UTF8-MAC";
    }
    if (!to) {
        to = "UTF-8";
    }
	var script = "php -f convert.php '" + string + "' " + from + " " + to;
	var output = widget.system(script, null).outputString;

	if (!output) {
		alert("error : " + widget.system(script, null).errorString);
		return "";
	}
    
    return output;
}

/*
 convert plist
*/
function arrayToPlistString(arr)
{
	var cnt = getLength(arr);
	var plist = "(";
	for (var i = 0; i < cnt; i++) {
		plist += "'" + arr[i] + "'";
		if (i != cnt - 1) {
			plist += ",";
		}
	}
	plist += ")";
	
	return plist;
}

function dictionaryToPlistString(dic)
{
	var plist = "{";
	for (var key in dic) {
		plist += "'" + key + "' = '" + dic[key] + "';";
	}
	plist += "}";
	
	return plist;
}

function plistStringToDictionary(plist)
{
//	alert(plist);
	var dic = new Array();
	// {}内部の要素
	var ret = plist.match(/{(.+?)}/);
	if (ret) {
		var content = ret[1];
//		alert(content);
		// * = *; を1つずつ
		ret = content.match(/.+?=.+?;/g);
		if (ret) {
//			alert(ret[0]);
			for (var i in ret) {
				// さらにkeyとvalueを別々に
				var keyval = ret[i].match(/(.+?)\s=\s(.+?);/);
				if (keyval) {
					dic[keyval[1]] = keyval[2];
				}
			}
		}
	}
	return dic;
}
